#include <map>
#include <vector>
#include <cstdio>
#include <tr1/unordered_map>
#include <tr1/unordered_set>

using namespace std;
using namespace std::tr1;

int jump = 100;

void go(int n, int m, int cc, int t) {
	map<pair<int, int>, int> vlast;
	vector<vector<unordered_set<int> > > sused(n+2, 
			vector<unordered_set<int> >(cc+2));
	vector<vector<unordered_set<int> > > fastsused(n+2, 
			vector<unordered_set<int> >(cc+2));
	for (int i = 0; i < m; i++) {
		int a, b, c; scanf("%d %d %d", &a, &b, &c);
		sused[a][c].insert(b);
		sused[b][c].insert(a);
		vlast[make_pair(a,b)] = c;
		vlast[make_pair(b,a)] = c;
	}
	for (int i = 0; i < n+2; i++) {
		for (int j = 0; j < cc+2; j++) {
			if (sused[i][j].size() == 1) {
				int last = 0;
				int cur = i;
				vector<int> walk;
				while (true) {
					int nn = 0;
					for (unordered_set<int>::iterator it = sused[cur][j].begin();
						 it != sused[cur][j].end(); ++it) {
						if (*it == last) continue;
						nn = *it;
					}
					walk.push_back(cur);
					if (nn == 0) break;
					last = cur;
					cur = nn;
				}
				for (int k = 0; k < walk.size(); k++) {
					int dr = k+jump;
					if (dr >= walk.size()) dr = walk.size()-1;
					fastsused[walk[k]][j].insert(walk[dr]);
				}
			}
		}
	}
	for (int i = 0; i < t; i++) {
		int a, b, c;
		scanf("%d %d %d", &a, &b, &c);
		if (vlast.count(make_pair(a,b)) == 0) {
			printf("No such cable.\n");
			continue;
		}
		if (vlast[make_pair(a,b)] == c) {
			printf("Already owned.\n");
			continue;
		}
		if (sused[a][c].size() == 2 || sused[b][c].size() == 2) {
			printf("Forbidden: monopoly.\n");
			continue;
		}
		if (sused[a][c].size() == 1 && sused[b][c].size() == 1) {
			int last = 0;
			int cur = a;
			while (true) {
				int nn = 0;
				for (unordered_set<int>::iterator it = sused[cur][c].begin();
					 it != fastsused[cur][c].end(); ++it) {
					if (*it == last) continue;
					nn = *it;
				}
				if (nn == 0) break;
				last = cur;
				cur = nn;
			}
			if (cur == b) {
				printf("Forbidden: redundant.\n");
				continue;
			}
		}
		printf("Sold.\n");
		int pov = vlast[make_pair(a,b)];
		sused[a][pov].erase(b);
		sused[b][pov].erase(a);
		sused[a][c].insert(b);
		sused[b][c].insert(a);
		vlast[make_pair(a,b)] = c;
		vlast[make_pair(b,a)] = c;
	}
	printf("\n");
}

int main() {
	while (true) {
		int n, m, c, t;
		scanf("%d %d %d %d", &n, &m, &c, &t);
		if (n==0) break;
		go(n, m, c, t);
	}
}
